Name "pws 0.3.0"
OutFile "pws-0.3.0.exe"
InstallDir $PROGRAMFILES\pws
InstallDirRegKey HKLM "Software\pws" "Install_Dir"
RequestExecutionLevel admin

SetCompressor /solid lzma

;--------------------------------
Page components
Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

;--------------------------------
 
!define WNDCLASS "QWidget"
!define WNDTITLE "pws"
 
Function .onInit   
	; check for running pws installer
	System::Call 'kernel32::CreateMutexA(i 0, i 0, t "pwsMutex") i .r1 ?e'
	Pop $R0
	
	StrCmp $R0 0 +3
		MessageBox MB_OK|MB_ICONEXCLAMATION "The installer is already running."
		Abort
	
	; check for previous installation
	ReadRegStr $0 HKLM SOFTWARE\pws "Install_Dir"
	
	IfFileExists $0\pws.exe 0 +3
		MessageBox MB_OK|MB_ICONEXCLAMATION "pws is already installed. Uninstall pws before reinstalling."
		Abort
FunctionEnd

Function un.onInit   
	; check for running pws process
	FindWindow $0 "${WNDCLASS}" "${WNDTITLE}"
	StrCmp $0 0 continueInstall
		MessageBox MB_OK|MB_ICONEXCLAMATION "pws is currently running. Close it and try again."
	 	Abort
	continueInstall:
	
	; check for running pws installer
	System::Call 'kernel32::CreateMutexA(i 0, i 0, t "pwsMutex") i .r1 ?e'
	Pop $R0
	
	StrCmp $R0 0 +3
		MessageBox MB_OK|MB_ICONEXCLAMATION "The uninstaller is already running."
		Abort
FunctionEnd

Section "pws (required)"
  SectionIn RO
  
  ; Set output path to the installation directory.
  SetOutPath $INSTDIR
  
  ; Put file there
  File pws.exe
  File QtNetwork4.dll
  File QtGui4.dll
  File QtCore4.dll
  File mingwm10.dll
  File libpws.dll.0.1.2
  File libgpg-error-0.dll
  File libgcrypt-11.dll
  
  ; Write the installation path into the registry
  WriteRegStr HKLM SOFTWARE\pws "Install_Dir" "$INSTDIR"
  
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\pws" "DisplayName" "pws"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\pws" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\pws" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\pws" "NoRepair" 1
  WriteUninstaller "uninstall.exe"
SectionEnd

; Optional section (can be disabled by the user)
Section "Start Menu Shortcuts"
  CreateDirectory "$SMPROGRAMS\pws"
  CreateShortCut "$SMPROGRAMS\pws\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\pws\pws.lnk" "$INSTDIR\pws.exe" "" "$INSTDIR\pws.exe" 0
SectionEnd

;--------------------------------

Section "Uninstall"
  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\pws"
  DeleteRegKey HKLM SOFTWARE\pws

  ; Remove files and uninstaller
  Delete $INSTDIR\QtNetwork4.dll
  Delete $INSTDIR\QtGui4.dll
  Delete $INSTDIR\QtCore4.dll
  Delete $INSTDIR\mingwm10.dll
  Delete $INSTDIR\libpws.dll.0.1.2
  Delete $INSTDIR\libgpg-error-0.dll
  Delete $INSTDIR\libgcrypt-11.dll
  Delete $INSTDIR\pws.exe
  Delete $INSTDIR\uninstall.exe

  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\pws\*.*"

  ; Remove directories used
  RMDir "$SMPROGRAMS\pws"
  RMDir "$INSTDIR"
SectionEnd
